// execif.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "execute.h"
#include "ini.h"
#include <windows.h>

/**
 * sB
 */
void ExecuteMulti(Values &values, HWND hWnd)
{
	Values::iterator it;
	for (it = values.begin(); it != values.end(); it++) {
		if (it->first == _T("exec")) {
			if (hWnd && (it->second == _T("close"))) {
				SendMessage(hWnd, WM_CLOSE, 0, 0);

			} else if (hWnd && (it->second == _T("active"))) {
				SetForegroundWindow(hWnd);

			} else {
				MomoLabUtil::ShellExecute(it->second);
			}

		} else if (it->first == _T("sleep")) {
			DWORD dwMilliseconds = _ttoi(it->second.c_str());
			Sleep(dwMilliseconds);
		}
	}
}

/**
 * 肵ĎsB
 */
void ExecuteIf(CIniFile &ini)
{
	std::wstring defaultStr = _T("");
	std::wstring defaultMode = _T("exec");
	BOOL isExec = FALSE;
	Sections::iterator it;
	Sections &sections = ini.GetSections();
	for (it = sections.begin(); it != sections.end(); it++) {
		if (it->first == _T("default")) continue;

		// class, title擾Bǂ炩Е΂悢
		const wchar_t *className = ini.GetValue(it->first, _T("class"), defaultStr).c_str();
		if (wcslen(className) == 0) className = NULL;
		const wchar_t *title = ini.GetValue(it->first, _T("title"), defaultStr).c_str();
		if (wcslen(title) == 0) title = NULL;
		if (className == NULL && title == NULL) continue;

		// mode擾BȂ΁AexecftHgƂ
		std::wstring &mode = ini.GetValue(it->first, _T("mode"), defaultMode);
		
		// EBhET
		HWND hWnd = FindWindow(className, title);
		if (hWnd && (
			(mode == _T("exec")) ||
			((mode == _T("active")) && (hWnd == GetForegroundWindow()))
		)) {
			ExecuteMulti(it->second, hWnd);
			isExec = TRUE;
		}

		// s烋[v𔲂
		if (isExec) break;
	}

	//ǂ̏ɂĂ͂܂Ȃ[default]s
	if (!isExec) {
		Values &values = ini.GetValues(_T("default"));
		ExecuteMulti(values, NULL);
	}
}

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	//R}hC͂iniǂݍ
	CIniFile* ini;
	if (wcslen(lpCmdLine) > 0) {
		ini = new CIniFile(lpCmdLine);
	} else {
		ini = new CIniFile(hInstance);
	}
	if (ini->Fail()) goto EXIT;

	try {
		//s
		ExecuteIf(*ini);
	} catch (wchar_t *) {
	}

EXIT:
	delete ini;
	return 0;
}
